#ifndef _STRLIST_
#define _STRLIST_
#include "share.h"

class  THIStrList:public TDebug
{
   private:
    TStrList *FList;
    
   public:
    string _prop_FileName;

    THI_Event *_data_FileName;
    THI_Event *_data_Str;
    THI_Event *_event_onChange;
    THI_Event *_event_onRead;   

    THIStrList(){ FList = new TStrList(); }
    HI_WORK_LOC(THIStrList,_work_doAdd);
    HI_WORK_LOC(THIStrList,_work_doClear);
    HI_WORK_LOC(THIStrList,_work_doDelete);
    HI_WORK_LOC(THIStrList,_work_doText);
    HI_WORK_LOC(THIStrList,_work_doLoad);
    HI_WORK_LOC(THIStrList,_work_doSave);
    HI_WORK_LOC(THIStrList,_work_doReplace);
    HI_WORK_LOC(THIStrList,_work_doRead);	   

    HI_WORK(_var_Text){ CreateData(_Data,_hie(THIStrList)->FList->Text); }
    HI_WORK(_var_Count){ CreateData(_Data,_hie(THIStrList)->FList->Count()); }

    void SetText(HI_STRING Value)
    {
       #ifdef UNICODE
         HI_STRING rbuf;
         AtoU((char *)Value,&rbuf);
         //MessageBox(NULL,L"ok",rbuf,MB_OK);
         FList->Text = string(rbuf);
         delete rbuf;
       #else
         FList->Text = string(Value);
       #endif
    }
    __declspec( property( put = SetText ) ) HI_STRING _prop_Strings;
};

//////////////////////////////////////////////////////////////////////////

void THIStrList::_work_doAdd(TData &_Data,WORD Index)
{
   FList->Add(ReadString(_Data,_data_Str,string(_his(""))));
   _hi_onEvent(_event_onChange);
}

void THIStrList::_work_doClear(TData &_Data,WORD Index)
{
   FList->Clear();
   _hi_onEvent(_event_onChange);
}

void THIStrList::_work_doDelete(TData &_Data,WORD Index)
{
   int ind = ToIntIndex(_Data);
   if( (ind >= 0) && (ind < FList->Count()) )
   {
      FList->Delete(ind);
      _hi_onEvent(_event_onChange);
   }
}

void THIStrList::_work_doText(TData &_Data,WORD Index)
{
     FList->Clear();
     FList->Text = ToString(_Data);
   _hi_onEvent(_event_onChange);
}

void THIStrList::_work_doLoad(TData &_Data,WORD Index)
{
   string fn = ReadString(_Data,_data_FileName,_prop_FileName);
   if( FileExists(fn) )
   {  FList->Clear();
      FList->LoadFromFile(fn);
      _hi_onEvent(_event_onChange);
   }
}

void THIStrList::_work_doSave(TData &_Data,WORD Index)
{
   string fn = ReadString(_Data,_data_FileName,_prop_FileName);
   FList->SaveToFile(fn);
}

void THIStrList::_work_doReplace(TData &_Data,WORD Index)
{  
   string s = ReadString(_Data,_data_Str,SNULL)+_his("\r\n");
   string store;
   string cr=L"\n";
   int SPos=0;
   int i=0;
   int ind = ToIntIndex(_Data);
   _Data.data_type = data_null;
   if( (ind >= 0)&&(ind < FList->Count()) )
   {   
   FList->Delete(ind);
      store = FList->Text;
        while(i<ind)
      {SPos = store.PosEx(cr,SPos+1);
           i++;}
       store.Insert(SPos,s);
       FList->Clear();
       FList->Text=store;
     _hi_onEvent(_event_onChange);
   }
}
void THIStrList::_work_doRead(TData &_Data,WORD Index)
{
    string n  = L"\n"; string r  = L"\r";
    string out;
     int ind = ToIntIndex(_Data);
     int SPos=0;    
    string Right = FList->Text;
       if( (ind >= 0)&&(ind < FList->Count()) )
       {
          for (int i = 0; i <ind; i++)
          {SPos = Right.PosEx(n,SPos);
		    Right.GetTok(n);}
          out = Right.GetTok(r);
        _hi_onEvent(_event_onRead,out);
       }
}
#endif